﻿#include <iostream>

double left(double f(double), double a, double b, int n)
{
	double h = (b - a) / n;
	double s = 0;
	for (int i = 0; i < n; i++) s += f(a + i * h);
	s *= h;
	return s;
}

double right(double f(double), double a, double b, int n)
{
	double h = (b - a) / n;
	double s = 0;
	for (int i = 1; i <= n; i++) s += f(a + i * h);
	s *= h;
	return s;
}

double trapezia(double f(double), double a, double b, int n)
{
	double h = (b - a) / n;
	double s = (f(a)+f(b))/2;
	for (int i = 1; i < n; i++) s += f(a + i * h);
	s *= h;
	return s;
}

double center(double f(double), double a, double b, int n)
{
	double h = (b - a) / n;
	double s = 0;
	for (int i = 0; i < n; i++) s += f(a + i * h + h / 2);
	s *= h;
	return s;
}

double sqr(double x)
{
	return x * x;
}


int main()
{
	for (int n = 10; n <= 1000; n *= 10)
		printf("%4d %10.8lf %10.8lf %10.8lf %10.8lf\n", n, 
			left(sqr, 0, 1, n),
			right(sqr, 0, 1, n),
			trapezia(sqr,0,1,n),
			center(sqr, 0, 1, n));
}

